% EMT Tavvezetek menetdiagram abrazolo
% Author: Papay Levente

clc;
clear all;

syms t;
syms s;

%% Paramterek megadsa, gerjesztes, halozat kivalasztasa
l = 47; % A tavvezetek hossza
Zn = 75; % A tavvezetek hullamimpedanciaja
R1 = 45; % A generator belso ellenallasa
R = 40; % A lezaras ellenallasa
L = 160;%e-7; % A lezaras induktivitasa 
%C = 40e-12; % A lezaras kapacitasa
zpl = 0.5; % Vizsgalati pozicio, z/l parameter
Tptau = 0.3; % A gerjesztesi ido, T/tau

c=0.3%e9;
tau = l/c
T = tau*Tptau
Tmax = 3*tau;

% A gerjeszt jelek definilsa
 u = R1*2*(heaviside(t) - heaviside(t-T)); % 1-es jel
%u = (heaviside(t) + heaviside(t-T)); % 2-es jel
% u = 2*(heaviside(t) - 2*heaviside(t-T) + heaviside(t-2*T)); % 3-as jel
% u = 2*(-heaviside(t) + 2*heaviside(t-T)); % 4-es jel

% A lezaro halozatok impedanciaja
% Z = R; % Az "a" feladathoz
% Z = R + s*L; % Soros RL
%Z = R + 1/s/C; % Soros RC
Z = (R*s*L) / (R + s*L); % Parhuzamos RL
% Z = R / (s*R*C + 1); % Parhuzamos RC

%% Egy kis szamolas
u1s =laplace(u)/(R1 + Zn); % A gerjeszto jel a feszosztval, 's' tartomanyban

r1s = (R1-Zn) / (R1+Zn) % Reflexios tenyezo a tavvezetek elejen, (masodik visszaverodes), 's' tartomany
r2s = (Z-Zn) / (Z+Zn) % Reflexios tenyezo a tavvezetek vegen, (elso visszaverodes), 's' tartomany

% A valasz meghatarozasa az eltolasokkal es reflexiokkal, 's' tartomanyban
us = u1s*( exp(-s*tau*zpl)  -   r2s*exp(-s*tau*(2-zpl))  +  r2s*r1s*exp(-s*tau*(2+zpl)) );

ut=ilaplace(us) % Visszateres idotartomanyra


%asd=R*Zn/(L*(R*Zn))*(tau*(2+Tptau))



%% Az eredmeny kirajzoltatasa
ez1 = ezplot(ut, [0, Tmax]);

set(ez1, 'color', 'red');
set(ez1, 'LineWidth',2);
title('A feszultseg idofuggvenye');
xlabel('Ido, [ns]');
ylabel('A feszultseg a vizsgalt pontban, [V]');
grid;
shg




